<template>
  <!-- 搜索工作栏 -->
  <ContentWrap>
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="标签名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入标签中文名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="标签分类" prop="category">
        <el-input
          v-model="queryParams.category"
          placeholder="请输入标签分类"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="标签状态" prop="status">
        <el-select
          v-model="queryParams.status"
          class="!w-240px"
          clearable
          placeholder="请选择状态"
        >
          <el-option
            v-for="dict in statusOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" row-key="id">
      <el-table-column label="标签名称" align="center" prop="name" />
      <el-table-column label="标签英文名称" align="center" prop="en_name" :show-overflow-tooltip="true" />
      <el-table-column label="标签分类" align="center" prop="category" />
      <el-table-column label="标签描述" align="center" prop="description" :show-overflow-tooltip="true" />
      <el-table-column label="标签状态" align="center" prop="status">
        <template #default="scope">
          <el-tag :type="scope.row.status === 'active' ? 'success' : 'danger'">
            {{ scope.row.status === 'active' ? '已启用' : '已禁用' }}
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" align="center" prop="time" width="180" />
      <el-table-column label="操作" align="center">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <TagForm ref="formRef" @success="getList" />
</template>
<script setup lang="ts" name="Tag">
import { talentTagApi } from '@/api/menduner/system/talentMap/tag'
import TagForm from './TagForm.vue'

const loading = ref(false)
const list = ref([])
const queryParams = reactive({
  name: undefined,
  category: undefined,
  status: undefined
})
const queryFormRef = ref() // 搜索的表单
const statusOptions = [
	{ label: '启用', value: 'active' },
	{ label: '禁用', value: 'disable' },
]

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await talentTagApi.getTalentTagList()
    list.value = data
  } finally {
    loading.value = false
  }
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, data?: any) => {
  formRef.value.open(type, data)
}

/** 搜索按钮操作 */
const handleQuery = () => {
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await talentTagApi.deleteTalentTag(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    setTimeout(async () => {
      await getList()
    }, 0)
  } catch {}
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>